/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VInputHelpparamCheckRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VInputHelpparamCheck extends TableImpl<VInputHelpparamCheckRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_input_helpparam_check</code>
     */
    public static final VInputHelpparamCheck V_INPUT_HELPPARAM_CHECK = new VInputHelpparamCheck();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VInputHelpparamCheckRecord> getRecordType() {
        return VInputHelpparamCheckRecord.class;
    }

    /**
     * The column <code>common_dd.v_input_helpparam_check.inputhelp</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, Integer> INPUTHELP = createField(DSL.name("inputhelp"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_input_helpparam_check.inputhelp_descr</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, String> INPUTHELP_DESCR = createField(DSL.name("inputhelp_descr"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam_check.param_order_nr</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, Integer> PARAM_ORDER_NR = createField(DSL.name("param_order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam_check.param_study</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, Integer> PARAM_STUDY = createField(DSL.name("param_study"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam_check.param_variable</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, Integer> PARAM_VARIABLE = createField(DSL.name("param_variable"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam_check.needed_params</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, Integer> NEEDED_PARAMS = createField(DSL.name("needed_params"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_input_helpparam_check.needed_params_actual</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, Long> NEEDED_PARAMS_ACTUAL = createField(DSL.name("needed_params_actual"), SQLDataType.BIGINT, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam_check.equals</code>.
     */
    public final TableField<VInputHelpparamCheckRecord, String> EQUALS = createField(DSL.name("equals"), SQLDataType.CLOB, this, "");

    private VInputHelpparamCheck(Name alias, Table<VInputHelpparamCheckRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VInputHelpparamCheck(Name alias, Table<VInputHelpparamCheckRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_input_helpparam_check" as  SELECT t_input_help.inputhelp,
          t_input_help.inputhelp_descr,
          hp.order_nr AS param_order_nr,
          hp.fk_study AS param_study,
          hp.fk_variable AS param_variable,
          t_input_help.needed_params,
          count(hp.pk) OVER (PARTITION BY hp.fk_inputhelp, hp.fk_study) AS needed_params_actual,
              CASE
                  WHEN (t_input_help.needed_params = count(hp.pk) OVER (PARTITION BY hp.fk_inputhelp, hp.fk_study)) THEN 'equal'::text
                  ELSE 'not equal'::text
              END AS equals
         FROM (common_dd.t_input_help
           LEFT JOIN common_dd.t_input_helpparam hp ON ((hp.fk_inputhelp = t_input_help.inputhelp)))
        ORDER BY t_input_help.inputhelp, hp.fk_study, hp.order_nr;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_input_helpparam_check</code> table
     * reference
     */
    public VInputHelpparamCheck(String alias) {
        this(DSL.name(alias), V_INPUT_HELPPARAM_CHECK);
    }

    /**
     * Create an aliased <code>common_dd.v_input_helpparam_check</code> table
     * reference
     */
    public VInputHelpparamCheck(Name alias) {
        this(alias, V_INPUT_HELPPARAM_CHECK);
    }

    /**
     * Create a <code>common_dd.v_input_helpparam_check</code> table reference
     */
    public VInputHelpparamCheck() {
        this(DSL.name("v_input_helpparam_check"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VInputHelpparamCheck as(String alias) {
        return new VInputHelpparamCheck(DSL.name(alias), this);
    }

    @Override
    public VInputHelpparamCheck as(Name alias) {
        return new VInputHelpparamCheck(alias, this);
    }

    @Override
    public VInputHelpparamCheck as(Table<?> alias) {
        return new VInputHelpparamCheck(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpparamCheck rename(String name) {
        return new VInputHelpparamCheck(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpparamCheck rename(Name name) {
        return new VInputHelpparamCheck(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpparamCheck rename(Table<?> name) {
        return new VInputHelpparamCheck(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparamCheck where(Condition condition) {
        return new VInputHelpparamCheck(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparamCheck where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparamCheck where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparamCheck where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparamCheck where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparamCheck where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparamCheck where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparamCheck where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparamCheck whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparamCheck whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
